#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  OrangeRed
#property indicator_width1  2
#property indicator_level1 0

extern int CyclePeriod = 32;
extern int Price       = PRICE_CLOSE;
double cycle[];
 
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()   { SetIndexBuffer(0,cycle); return(0); }
int deinit() {                          return(0); }

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double work[][1];
#define _velo1 0
#define _velo2 0

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //    Velo1:= Mov(C,period,S);
   //    Velo2:= C - Velo1;
   //    Velo5:= Ref(Velo2,-period);
   //    Velo6:= Velo2 - Velo5;
   //    MMVelo:= Mov(Velo6,period/2,S);
   //    MMVelo; 
   //
   //
   //

   int halfPeriod = MathCeil(CyclePeriod/2.0);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
                      work[r][_velo2] = price-iSma(price,CyclePeriod,i,0);
      cycle[i] = iSma(work[r][_velo2]-work[r-CyclePeriod][_velo2],halfPeriod,i,1);
   }
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workSma[][4];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

